#include <stdio.h>    
#include <string.h>    
#include "svio.h"

char *_STRING_cvt_svio(char *in,int n) {
   char *out;
   int   i;
   out = (char *) malloc((n + 1) * sizeof(char));
   strncpy(out,in,n);
   out[n] = '\0';

   for(i = n - 1;i >= 0 && out[i] == ' ';i--);
   if(i >= 0 && i < n) out[i+1] = '\0';

   return out;
}

char **_VSTRING_cvt_svio(char *in,int elemlen,int ns) {
   char **out;
   int  i,  j;
   out = (char **) malloc(ns * sizeof(char *));
   for( i = 0; i < ns; i++ ) {
      out[i] = (char *)  malloc((elemlen + 1) * sizeof(char));
      strncpy(out[i],in + i * elemlen,elemlen);
      out[i][elemlen] = '\0';
      for(j = elemlen - 1; j >= 0 && out[i][j] == ' '; j--);
      if( j >= 0 && j < elemlen ) out[i][j+1] = '\0';
   }
   return out;
}

void _STRCPY_cvt_svio(char *out,char *in,int n) {
   strncpy(out,in,strlen(in));
}

void _VSTRCPY_cvt_svio(char *out,char **in,int elemlen,int ns) {
   int  i;
   for( i = 0; i < ns; i++ ) {
      strncpy(out + i * elemlen,in[i],strlen(in[i]));
   }
}

void _free_VSTRING_cvt_svio(char **s,int ns) {
   int    i;
   for( i = 0; i < ns; i++ ) {
      if( s[i] ) free(s[i]);
   }
   if( s ) free(s);
}

int gft_out_sv_(
   char * func_name,
   double * p_time,
   int * shape,
   int * p_rank,
   double * data,
   int len_func_name ) {

   int _mfi_rval;
   char * l_func_name;

   l_func_name = _STRING_cvt_svio(func_name,len_func_name);

   _mfi_rval = gft_out_sv(
      l_func_name,
      *p_time,
      shape,
      *p_rank,
      data      );

   /* func_name is 'const' ... */


   free(l_func_name);

   return _mfi_rval;
}

int gft_out_brief_sv_(
   char * func_name,
   double * p_time,
   int * shape,
   int * p_rank,
   double * data,
   int len_func_name ) {

   int _mfi_rval;
   char * l_func_name;

   l_func_name = _STRING_cvt_svio(func_name,len_func_name);

   _mfi_rval = gft_out_brief_sv(
      l_func_name,
      *p_time,
      shape,
      *p_rank,
      data      );

   /* func_name is 'const' ... */


   free(l_func_name);

   return _mfi_rval;
}

int gft_out_bbox_sv_(
   char * func_name,
   double * p_time,
   int * shape,
   int * p_rank,
   double * coords,
   double * data,
   int len_func_name ) {

   int _mfi_rval;
   char * l_func_name;

   l_func_name = _STRING_cvt_svio(func_name,len_func_name);

   _mfi_rval = gft_out_bbox_sv(
      l_func_name,
      *p_time,
      shape,
      *p_rank,
      coords,
      data      );

   /* func_name is 'const' ... */


   free(l_func_name);

   return _mfi_rval;
}

int gft_out_full_sv_(
   char * func_name,
   double * p_time,
   int * shape,
   char * cnames,
   int * p_rank,
   double * coords,
   double * data,
   int len_func_name,
   int len_cnames ) {

   int _mfi_rval;
   char * l_func_name;
   char ** l_cnames;

   l_func_name = _STRING_cvt_svio(func_name,len_func_name);
   l_cnames = _VSTRING_cvt_svio(cnames,len_cnames,*p_rank);

   _mfi_rval = gft_out_full_sv(
      l_func_name,
      *p_time,
      shape,
      l_cnames,
      *p_rank,
      coords,
      data      );

   /* func_name is 'const' ... */
   _VSTRCPY_cvt_svio(cnames,l_cnames,len_cnames,*p_rank);


   free(l_func_name);
   _free_VSTRING_cvt_svio(l_cnames,*p_rank);

   return _mfi_rval;
}

int gft_outm_sv_(
   char * func_name,
   double * time,
   int * shape,
   int * p_nt,
   int * rank,
   double * data,
   int len_func_name ) {

   int _mfi_rval;
   char * l_func_name;

   l_func_name = _STRING_cvt_svio(func_name,len_func_name);

   _mfi_rval = gft_outm_sv(
      l_func_name,
      time,
      shape,
      *p_nt,
      rank,
      data      );

   /* func_name is 'const' ... */


   free(l_func_name);

   return _mfi_rval;
}

int gft_outm_brief_sv_(
   char * func_name,
   double * time,
   int * shape,
   int * p_nt,
   int * rank,
   double * data,
   int len_func_name ) {

   int _mfi_rval;
   char * l_func_name;

   l_func_name = _STRING_cvt_svio(func_name,len_func_name);

   _mfi_rval = gft_outm_brief_sv(
      l_func_name,
      time,
      shape,
      *p_nt,
      rank,
      data      );

   /* func_name is 'const' ... */


   free(l_func_name);

   return _mfi_rval;
}

int gft_outm_bbox_sv_(
   char * func_name,
   double * time,
   int * shape,
   int * p_nt,
   int * rank,
   double * coords,
   double * data,
   int len_func_name ) {

   int _mfi_rval;
   char * l_func_name;

   l_func_name = _STRING_cvt_svio(func_name,len_func_name);

   _mfi_rval = gft_outm_bbox_sv(
      l_func_name,
      time,
      shape,
      *p_nt,
      rank,
      coords,
      data      );

   /* func_name is 'const' ... */


   free(l_func_name);

   return _mfi_rval;
}

int gft_outm_full_sv_(
   char * func_name,
   double * time,
   int * shape,
   char * cnames,
   int * p_nt,
   int * rank,
   double * coords,
   double * data,
   int len_func_name,
   int len_cnames ) {

   int _mfi_rval;
   char * l_func_name;
   char ** l_cnames;

   l_func_name = _STRING_cvt_svio(func_name,len_func_name);
   l_cnames = _VSTRING_cvt_svio(cnames,len_cnames,*p_nt);

   _mfi_rval = gft_outm_full_sv(
      l_func_name,
      time,
      shape,
      l_cnames,
      *p_nt,
      rank,
      coords,
      data      );

   /* func_name is 'const' ... */
   _VSTRCPY_cvt_svio(cnames,l_cnames,len_cnames,*p_nt);


   free(l_func_name);
   _free_VSTRING_cvt_svio(l_cnames,*p_nt);

   return _mfi_rval;
}

