// Generated from Scivis filter creation widget.
// For further information, please refer other filter
// implementations included in Scivis release.

package user;

import java.util.*;
import sv.kernel.*;

/**
 * svmInterp.java
 */

public class svmInterp extends Filter {

	public svmInterp() {
		super(DataSet.ONED,1);
    label = "Enter the # of points in the interpolation mesh";
	}

	public Object performFilter() {

		String title = "Interp";
		Vector timeDataVec = new Vector();
    int npoints = (int)args[0];

		int points;
    float alpha,beta;

		TimeData1D onetimedata;
		DataSet1D dataSet = (DataSet1D)sources.firstElement();
    float[] xArr,yArr;

    float xMin = (float)1000.0;
    float xMax = -(float)10000.0;
    float gxmin=xMax,gxmax=xMin;
		for (int i=0; i<dataSet.getnoOfTime(); i++) {
		   onetimedata = (TimeData1D)dataSet.timeData[i];
		   points = onetimedata.getnoOfPoints();
		   xArr = onetimedata.getxArr();
		   yArr = onetimedata.getyArr();
       for(int j=0; j<points; j++){                         
          if (xArr[j]<xMin) xMin = xArr[j];
          if (xArr[j]>xMax) xMax = xArr[j];
       }
       if (xMin>gxmin) gxmin = xMin;
       if (xMax<gxmax) gxmax = xMax;

    }
    xMin = gxmin+(float)0.1; xMax = gxmax-(float)0.1;
		for (int i=0; i<dataSet.getnoOfTime(); i++) {
		  onetimedata = (TimeData1D)dataSet.timeData[i];
		  points = onetimedata.getnoOfPoints();
		   
		   //Start non-template code
		   xArr = onetimedata.getxArr();
		   yArr = onetimedata.getyArr();
		   
		   float[] newXArr = new float[npoints];
		   float[] newYArr = new float[npoints];
		   
		   float deltaX = (xMax - xMin)/(npoints - 1);
       for (int j = 0;j<npoints;j++) {
         newXArr[j] = xMin + deltaX*j;
       }
       // newYArr[0] = yArr[0];
       //newYArr[npoints-1] = yArr[points-1];

       int ip;
		   for(int j=0; j<npoints; j++){
         for(int k=0;k<points;k++) {
           if (xArr[k]>newXArr[j]) {
             ip = k -1;
             alpha = (newXArr[j]-xArr[k]);
             beta = -newXArr[j]+xArr[ip];
             newYArr[j]=(alpha*yArr[ip] + beta*yArr[k])/(alpha+beta);
             break; 
           }
         }
       }
		   onetimedata = new TimeData1D(dataSet.getTimeValue(i),npoints,
						                        newXArr, newYArr);
		   
		   newXArr = null;
		   newYArr = null;
		   //End non-template code
		   
		   
		   
//		  onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, 
//				onetimedata.getxArr(), onetimedata.getyArr());
		  timeDataVec.addElement(onetimedata);
		}
		return new DataSet1D(title, timeDataVec);
	}

} // end of class
