package user;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * DerivFilter.java
 * New dataset with a subtracted time 
 * @version 1.0
 * @author Scott Klasky 
 */

public class SubTime extends Filter {


  public Subtime() {
     super(DataSet.ONED,1); 
     label = "Enter the subtraction of the time";
      tsub= (float) args[0];
  }


  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr; 
     int points;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        onetimedata = new TimeData1D(dataSet.getTimeValue(i)-tsub,points,xarr,yarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("tsub" + dataSet.getTitle(), timeDataVec);
  }

}





